Subject: Re: [trill] Asymmetric link costs and D-Tree calculations

From: Olen Stokes <[email-masked]>
Date: Fri, 1 Mar 2013 04:22:18 -0800

Thanks for the feedback.

Cheers,
Olen

-----Original Message-----
From: Donald Eastlake [mailto:[email-masked]] 
Sent: Friday, March 01, 2013 2:21 AM
To: Olen Stokes
Cc: [email-masked]
Subject: Re: [trill] Asymmetric link costs and D-Tree calculations

Hi Olen,

On Thu, Feb 28, 2013 at 1:21 PM, Olen Stokes <[email-masked]> wrote:
> Appendix A.1 of RFC 6325 discusses the fact that "two RBridges may 
> know they are connected but each sees the link as a different speed 
> from how it is seen by the other."

Yes, and asymmetry can also occur through manual cost configuration of costs.

> We have been looking at this and how it relates to D-Tree calculation 
> as discussed in Section 4.5.1.  In that section, it states, "Each 
> RBridge RBn independently calculates a tree rooted at RBi by 
> performing the SPF (Shortest Path First) calculation with RBi as the 
> root".  So, it appears that the D-Tree is calculated from the root RBridge outward.
>
> The following three paragraphs describe how to determine the potential 
> parents P for a node N.  There does not appear to be any mention of 
> direction so it would seem that all calculations are done in the 
> direction from the root RBi outward.

That was the intent. The tree is calculated through a Dijkstra SPF process starting at the Root and working outwards.

> The last paragraph in Section 4.5.1 states, "In other words, the set 
> of potential parents for N, for the tree rooted at R, consists of 
> those that give equally minimal cost paths from N to R and that have 
> distinct IS-IS IDs, based on what is reported in LSPs."  In this case, 
> costs are discussed as inward from node N towards root RBi.

That text in RFC 6325 is wrong, as far as I know.

> This change in direction of cost calculation could potentially be 
> confusing when there are asymmetric link costs as described in 
> Appendix A.1.  For any parent P found during the SPF calculation, it 
> is possible that the cost from N to P is different than the cost from 
> P to N.  It is also possible that none of the parents found during the 
> SPF calculation are found along any of the "equally minimal cost paths 
> from N to R".

Yes.

Although I think the asymmetric costs will be rarely encountered, it is critical that all RBridges calculate the same tree so the method must be unambiguous.

> Is the potential change of direction when calculating costs in the 
> last paragraph unintended?  Would the paragraph have been more clear 
> discussing "equally minimal cost paths from R to N"?

Yes, thanks for spotting this. It should have said "from R to N" or something like that. I'll file an Errata against RFC 6325.

> Is there agreement in the presence of asymmetric link costs that it is 
> possible that none of the parents found during the SPF calculation are 
> found along any of the "equally minimal cost paths from N to R" 
> calculated for known unicast traffic?

It seems to me that could happen.

Thanks,
Donald
=============================
 Donald E. Eastlake 3rd   +1-508-333-2270 (cell)
 155 Beaver Street, Milford, MA 01757 USA  [email-masked]

> Cheers,
> Olen

---

From: Donald Eastlake <[email-masked]>
Date: Fri, 8 Mar 2013 23:26:01 -0500

Hi,

As I said I would below, I did file an Errata against RFC 6325.
Although the notice I got saying it had been filled appeared to cc the
TRILL WG mailing list, I don't see that mail in the archive. So I'm
posting a pointer to it here:

http://www.rfc-editor.org/errata_search.php?rfc=6325&eid=3508

Thanks,
Donald
=============================
 Donald E. Eastlake 3rd   +1-508-333-2270 (cell)
 155 Beaver Street, Milford, MA 01757 USA
 [email-masked]

On Fri, Mar 1, 2013 at 2:21 AM, Donald Eastlake <[email-masked]> wrote:
>> Appendix A.1 of RFC 6325 discusses the fact that “two RBridges may know they
>> are connected but each sees the link as a different speed from how it is
>> seen by the other.”
>
>> We have been looking at this and how it relates to D-Tree calculation as
>> discussed in Section 4.5.1.  In that section, it states, “Each RBridge RBn
>> independently calculates a tree rooted at RBi by performing the SPF
>> (Shortest Path First) calculation with RBi as the root”.  So, it appears
>> that the D-Tree is calculated from the root RBridge outward.
>>
>> direction so it would seem that all calculations are done in the direction
>> from the root RBi outward.
>
> That was the intent. The tree is calculated through a Dijkstra SPF
> process starting at the Root and working outwards.
>
>> The last paragraph in Section 4.5.1 states, “In other words, the set of
>> potential parents for N, for the tree rooted at R, consists of those that
>> give equally minimal cost paths from N to R and that have distinct IS-IS
>> IDs, based on what is reported in LSPs.”  In this case, costs are discussed
>> as inward from node N towards root RBi.
>
>> This change in direction of cost calculation could potentially be confusing
>> when there are asymmetric link costs as described in Appendix A.1.  For any
>> parent P found during the SPF calculation, it is possible that the cost from
>> N to
>> P is different than the cost from P to N.  It is also possible that none of
>> the parents found during the SPF calculation are found along any of the
>> “equally minimal cost paths from N to R”.
>
> Yes.
>
> Although I think the asymmetric costs will be rarely encountered, it
> is critical that all RBridges calculate the same tree so the method
> must be unambiguous.
>
>> Is the potential change of direction when calculating costs in the last
>> paragraph unintended?  Would the paragraph have been more clear discussing
>> “equally minimal cost paths from R to N”?
>
> Yes, thanks for spotting this. It should have said "from R to N" or
> something like that. I'll file an Errata against RFC 6325.
>
>> possible that none of the parents found during the SPF calculation are found
>> along any of the “equally minimal cost paths from N to R” calculated for
>> known unicast traffic?
>